#!/usr/bin/env node

/*
 * @Author: luzc
 * @Date: 2019-10-01 17:13:19
 * @LastEditTime: 2019-10-01 17:26:43
 * @LastEditors: luzc
 * @Description: cli构建文件
 */

const program = require('commander');
const getCliOptions = require('../utils/getCliOptions');
const Context = require('../core/Context');
const log = require('../utils/log');

program
  .option('--config <config>', '自定义参数配置')
  .option('--analyzer', '开启构建分析')
  .option('--analyzer-port', '设置分析端口号')
  .parse(process.argv);

(async () => {
  process.env.NODE_ENV = 'production';
  const cliOptions = getCliOptions(program);
  try {
    await new Context({
      command: 'build',
      args: cliOptions,
    }).run();
  } catch (err) {
    log.error(err.message);
    console.error(err);
    process.exit(1);
  }
})();
