/*
 * @Author: luzc
 * @Date: 2019-10-01 17:13:19
 * @LastEditTime: 2019-10-01 17:26:43
 * @LastEditors: luzc
 * @Description: 开发环境启动
 */
const { fork } = require('child_process');

/**
 * 重新开子进程
 * @param scriptPath
 * @returns {ChildProcess}
 */
function restartProcess(scriptPath) {
  const child = fork(scriptPath, process.argv.slice(2));
  child.on('message', (data) => {
    // 用户修改zen.config.js时重新启动
    if (data && data.type === 'RESTART_DEV') {
      child.kill();
      restartProcess(scriptPath);
    }
    if (process.send) {
      process.send(data);
    }
  });
  return child;
}

const devChild = restartProcess(require.resolve('./child-process-dev.js'));
devChild.on('exit', (code) => {
  if (code && code !== 0) {
    process.exit(code);
  }
});
process.on('SIGINT', () => {
  devChild.kill('SIGINT');
});
