/*
 * @Author: luzc
 * @Date:  2019/10/02
 * @Description: webpack公共配置
 */
const WebpackChain = require('webpack-chain');
const { appDir } = require('../utils/paths');
const setLoaders = require('./setWebpackLoaders');
const setPlugins = require('./setWebpackPlugins');

module.exports = (mode = 'development', zenConfig = {}) => {
  const chainConfig = new WebpackChain();

  chainConfig
    .mode(mode)
    .context(appDir);

  // webpack loader 配置
  setLoaders(chainConfig, mode, zenConfig);

  // webpack plugin 配置
  setPlugins(chainConfig, mode, zenConfig);

  return chainConfig;
};
