/*
 * @Author: luzc
 * @Date:  2019/10/02
 * @Description: 获取命令行参数配置
 */
const { BundleAnalyzerPlugin } = require('webpack-bundle-analyzer');

module.exports = async ({ context, chainWebpack }) => {
  const { commandArgs } = context;
  chainWebpack(config => {
    if (commandArgs.disabledReload) {
      config.plugins.delete('HotModuleReplacementPlugin');

      // 移除 css hot loader of scss/module-scss/css/module-css/less/module-less
      ['scss', 'scss-module', 'css', 'css-module', 'less', 'less-module'].forEach((rule) => {
        if (config.module.rules.get(rule)) {
          config.module.rule(rule).uses.delete('css-hot-loader');
        }
      });
      config.devServer.hot(false);
    }

    if (commandArgs.analyzer) {
      config.plugin('webpack-bundle-analyzer')
        .use(BundleAnalyzerPlugin, [{ analyzerPort: commandArgs.analyzerPort || '9000' }]);
    }

    config.devServer.https(false);
  });
};
