/*
 * @Author: luzc
 * @Date:  2019/10/02
 * @Description: 
 */
const chalk = require('chalk');
const log = require('../../utils/log');

module.exports = (api) => {
  const { userConfig = {} } = api.context;
  const configKeys = Object.keys(userConfig);
  configKeys.forEach((configKey) => {
    if (['plugins', 'chainWebpack', 'addBabelPlugins', 'eslint'].indexOf(configKey) === -1) {
      try {
        const configPlugin = require(`./configs/${configKey}`);
        configPlugin(api, userConfig[configKey]);
      } catch (e) {
        log.error(e);
        log.error(`Config ${chalk.bold(configKey)} is not defined`);
      }
    }
  });
};
