/*
 * @Author: luzc
 * @Date: 2019-10-01 16:37:31
 * @LastEditTime: 2019-10-01 16:39:24
 * @LastEditors: luzc
 * @Description: 路径
 */

const path = require('path');
const fs = require('fs');

const appDir = fs.realpathSync(process.cwd());
const resolve = dir => path.resolve(appDir, dir);

const moduleFileExtensions = [
  'web.mjs',
  'mjs',
  'web.js',
  'js',
  'web.ts',
  'ts',
  'web.tsx',
  'tsx',
  'json',
  'web.jsx',
  'jsx'
];

const resolveModule = (filePath) => {
  const extension = moduleFileExtensions.find(ext =>
    fs.existsSync(resolve(`${filePath}.${ext}`))
  );

  if (extension) {
    return resolve(`${filePath}.${extension}`);
  }

  return resolve(`${filePath}.js`);
};

module.exports = {
  appPath: resolve('.'),
  appIndexJs: resolveModule('src/index'),
  appSrc: resolve('src'),
  appDist: resolve('dist'),
  appPublic: resolve('public'),
  appHtml: resolve('public/index.html'),
  appNodeModules: resolve('node_modules'),
  appPackageJson: resolve('package.json'),
  appFavicon: resolve('public/favicon.ico'),
  moduleFileExtensions,
  appDir,
  resolve
};
